require 'dogeify/version'
require 'engtagger'

class Dogeify
  ADJECTIVES=%w(so such very much many).freeze

  def initialize
    @tagger = EngTagger.new
  end

  def process(input)
    input = input.downcase

    nouns =find_nouns_in_text(input)

    phrases = prefix_nouns_with_adjectives(nouns)

    phrases = end_phrases_with_wow(phrases)

    phrases.join(' ')
  end

  private

  def adjective(i)
    ADJECTIVES[i % ADJECTIVES.size]
  end

  def tag_text(input)
    @tagger.add_tags(input)
  end

  def find_nouns_in_text(input)
    tagged_input = tag_text(input)
    nouns =@tagger.get_nouns(tagged_input).keys
  end

  def prefix_nouns_with_adjectives(nouns)
    phrases = nouns.each_with_index.map do |noun, i|
      "#{adjective(i)} #{noun}."
    end
  end

  def end_phrases_with_wow(phrases)
    phrases << 'wow.'
  end
end